import javax.microedition.midlet.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import java.io.*;

public class Client extends MIDlet implements Runnable, CommandListener
{   private Display display;
    private Form f;
    private boolean stop;

    private Command startCommand= new Command("Start",Command.ITEM,1);

    DataInputStream is;
    DataOutputStream os;
    SocketConnection sc;
    
    GameCanvas canvas;
    
    Image login;

    public Client()
    {	try
    	{	login=Image.createImage("/Logo.png");
    	}
    	catch(Exception e)
    	{	e.printStackTrace();	}
    
    	display = Display.getDisplay(this);
        f = new Form(":: Pillage Mobile ::");
        f.append(login);
        f.addCommand(startCommand);
        f.setCommandListener(this);
        display.setCurrent(f);
        
        canvas=new GameCanvas(this);
        
        try
    	{	sc = (SocketConnection)Connector.open("socket://localhost:3000");

            is  = sc.openDataInputStream();
            os = sc.openDataOutputStream();
            new Thread(this).start();
        } 
        catch (ConnectionNotFoundException cnfe)
        {	Alert a = new Alert("Client","No Connection Found!",null,AlertType.ERROR);
            a.setTimeout(Alert.FOREVER);
            a.setCommandListener(this);
            display.setCurrent(a);
        }
       	catch (IOException ioe)
       	{	ioe.printStackTrace();
        }
        catch (Exception e)
        {	e.printStackTrace();
        }
    }
	public void sendMessage(String message)
	{	try
		{	os.writeUTF(message);
		}
		catch( IOException ie )	{}
	}
    public void run()
    {	try
    	{	while (true)
	        {	String message = is.readUTF();
	            //System.out.println(message);
	            
	            if(message.startsWith("/playerNumber"))	// recieves server-assigned player #
				{	message=message.substring(14);
					//System.out.println("PLAYER NUMBER SET TO "+message);
					canvas.playerNumber=Integer.parseInt(message);
				}
				else if(message.startsWith("/disableStart")) // recieves the official startgame from server
				{	//System.out.println("DISABLING START MENU");
					display.setCurrent(canvas);
				}
				else if(message.startsWith("/startGame")) // recieves the official startgame from server
				{	//System.out.println("STARTING GAME");
					canvas.gameStarted=true;
				}
				else if(message.startsWith("/mapData"))
				{	//System.out.println("INITIALIZING MAP");
					canvas.initMap();
					
					canvas.drawMap=true;
					canvas.repaint();
				}
				else if(message.startsWith("/playerData"))
				{	message=message.substring(12);
					String[] temp=split(message,',');		//0->playerNum 1->X 2->Y 3->Facing
					
					//System.out.println("UPDATING INFO OF PLAYER "+temp[0]+"-"+temp[1]+","+temp[2]+" FACING "+temp[3]);
					
					//Updates the previous location of the player to a "SPACE" whenever he moves
					int prevX=((PlayerInfo)canvas.pi.elementAt(Integer.parseInt(temp[0])-1)).getX();
					int prevY=((PlayerInfo)canvas.pi.elementAt(Integer.parseInt(temp[0])-1)).getY();
					if(prevX<=canvas.blocks&&prevY<=canvas.blocks)
						canvas.map[prevX][prevY]="SPACE";
					
					if(canvas.drawPowerUp&&
					   Integer.parseInt(temp[1])==Integer.parseInt(canvas.powerUp[0])&&
					   Integer.parseInt(temp[2])==Integer.parseInt(canvas.powerUp[1]))
					{	canvas.drawPowerUp=false;
					}
					
					((PlayerInfo)canvas.pi.elementAt(Integer.parseInt(temp[0])-1)).setX(Integer.parseInt(temp[1]));
					((PlayerInfo)canvas.pi.elementAt(Integer.parseInt(temp[0])-1)).setY(Integer.parseInt(temp[2]));
					((PlayerInfo)canvas.pi.elementAt(Integer.parseInt(temp[0])-1)).setFacing(temp[3]);
					
					canvas.drawPlayers=true;
					canvas.repaint();
				}
				else if(message.startsWith("/powerUp"))
				{	message=message.substring(9);
					canvas.powerUp=split(message,',');
					
					//System.out.println("RECIEVED UPDATE ON MAP "+canvas.powerUp[0]+","+canvas.powerUp[1]+","+canvas.powerUp[2]);
					canvas.drawPowerUp=true;
				}
				else if(message.startsWith("/bulletData"))
				{	message=message.substring(12);
				
					if(message.equals("CLEAR"))
					{	//System.out.println("CLEARING SCREEN OF BULLETS");
						canvas.hasFired=null;
						canvas.repaint();
					}
					else
					{	canvas.hasFired=split(message,' ');
						//System.out.println("RECIEVED UPDATE ON "+canvas.hasFired.length+" BULLET(S).");
						canvas.repaint();
					}
				}
				else if(message.startsWith("/gameFinished"))
				{	message=message.substring(14);
					
					String[] playerStats=split(message,' ');
					
					String[] scores;
					String scoresText=new String();
					String yourScoreText=new String();
					for(int i=0;i<playerStats.length;i++)	
					{	scores=split(playerStats[i],',');	//0->PlayerNumber 1->Score
						
						if(i!=canvas.playerNumber-1)
						{	scoresText=scoresText+"Player "+(i+1)+"'s Score: "+scores[1]+"\n";
						}
						else
						{	yourScoreText="YOUR SCORE: "+scores[1];
						}
					}
					scoresText=scoresText+"\n"+yourScoreText;
					f=new Form(":: Pillage Mobile ::");
					f.append("Game Finished:");
					f.append(scoresText);
					display.setCurrent(f);
					System.exit(0);
				}
	        }
	 	}
	 	catch(IOException ie)	{}	
    }
    public void commandAction(Command c, Displayable s)
    {	if(c==startCommand)
        {	sendMessage("/startGame");
        	display.setCurrent(canvas);
        }
        
        if (c == Alert.DISMISS_COMMAND)
        {	destroyApp(true);
        }
    }
    public void startApp()
	{	display.setCurrent(f);
	}
	public void pauseApp()	{}
	public void destroyApp(boolean unconditional)	{}
	public String[] split(String input,char splitby)
	{	int ctr=0;
		int matches=0;
		String[] output;
		
		while(ctr<input.length())
		{	if(input.charAt(ctr)==splitby)
			{	matches++;
			}
			ctr++;
		}
		output=new String[matches+1];
		
		int from=999999999;
		int to=0;
		int outputCtr=0;
		for(int i=0;i<input.length();i++)
		{	if(from==999999999)
			{	from=i;
			}
			else if(input.charAt(i)==splitby)
			{	to=i;
				output[outputCtr++]=input.substring(from,to);
				from=999999999;
			}
			
			if(i==input.length()-1)
			{	to=i+1;
				output[outputCtr++]=input.substring(from,to);
			}
		}
		return output;
	}
}