import java.util.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

class GameCanvas extends Canvas
{	Client client;
	int playerNumber;
	boolean gameStarted;
	
	int blockSize=10;
	int blocks=17;
	Image[] tankUP,tankDOWN,tankLEFT,tankRIGHT;
	Image 	block,bullet,coin;
	Image 	timefreeze,firepower;
	
	//Flags & Resources for use by PaintComponent
	boolean drawMap=false;
	boolean drawPlayers=false;
	boolean drawPowerUp=false;
	String[] powerUp;
	String[][] map;
	Vector pi;
	String[] hasFired;
	
	public GameCanvas(Client client)
	{	this.client=client;
		gameStarted=false;
		loadImages();
		
		initMap();
		initPlayerData();
		map=new String[17][17];
	}
	public void initPlayerData()
	{	pi=new Vector();
		for(int i=0;i<4;i++)
		{	pi.addElement(new PlayerInfo(blocks+1,blocks+1,"",(i+1)));
		}
	}
	public void initMap()
	{	map=new String[17][17];
	
		//BORDER
		for(int i=0;i<17;i++)
			for(int j=0;j<17;j++)
				if(i==0||i==16||j==0||j==16)
					map[j][i] = new String("BLOCK");
		//ROWS 2,5,13,16
		for(int i=1;i<16;i++) 
			if(i==1||i==15)
			{	map[i][1] = new String("SPACE");
				map[i][4] = new String("COIN");
				map[i][12]= new String("COIN");
				map[i][15]= new String("SPACE");
			}
			else
			{	map[i][1] = new String("COIN");
				map[i][4] = new String("COIN");
				map[i][12]= new String("COIN");
				map[i][15]= new String("COIN");
			}
		//ROW 3 AND ROW 15
		for(int i=1;i<16;i++)
			if(i==1||i==8||i==15) {
				map[i][2] = new String("COIN");
				map[i][14]= new String("COIN");
			}
			else {
				map[i][2] = new String("BLOCK");
				map[i][14]= new String("BLOCK");
			}
		//ROWS 4,6,7,11,12,14		
		for(int i=1;i<16;i++)
			if(i==2||i==7||i==9||i==14)
			{	map[i][3] = new String("BLOCK");
				map[i][5] = new String("BLOCK");
				map[i][6] = new String("BLOCK");
				map[i][10]= new String("BLOCK");
				map[i][11]= new String("BLOCK");
				map[i][13]= new String("BLOCK");
			}
			else
			{	map[i][3] = new String("COIN");
				map[i][5] = new String("COIN");
				map[i][6] = new String("COIN");
				map[i][10]= new String("COIN");
				map[i][11]= new String("COIN");
				map[i][13]= new String("COIN");
			}
		//ROW 8 AND ROW 10
		for(int i=1;i<16;i++)
			if(i==2||i==5||i==6||i==7||i==9||i==10||i==11||i==14)
			{	map[i][7] = new String("BLOCK");
				map[i][9] = new String("BLOCK");
			}
			else 
			{	map[i][7] = new String("COIN");
				map[i][9] = new String("COIN");
			}
		//ROW 9
		for(int i=1;i<16;i++)
			if(i==1||i==2||i==14||i==15) 
				map[i][8] = new String("BLOCK");
			else
				map[i][8] = new String("COIN");				
	}
	public void loadImages()
	{	tankUP		=new Image[4];
		tankDOWN	=new Image[4];
		tankLEFT	=new Image[4];
		tankRIGHT	=new Image[4];
		try
    	{	for(int i=0;i<4;i++)
			{	tankUP[i]		=Image.createImage("/Tank"+(i+1)+" UP.png");
				tankDOWN[i]		=Image.createImage("/Tank"+(i+1)+" DOWN.png");
				tankLEFT[i]		=Image.createImage("/Tank"+(i+1)+" LEFT.png");
				tankRIGHT[i]	=Image.createImage("/Tank"+(i+1)+" RIGHT.png");
			}
			block		=Image.createImage("/Block.png");
			bullet		=Image.createImage("/Bullet.png");
			coin		=Image.createImage("/Coin.png");
			timefreeze	=Image.createImage("/Timefreeze.png");
			firepower	=Image.createImage("/Firepower.png");
		}
		catch(Exception e)
		{	e.printStackTrace();	}
	}
	public void paint(Graphics g)
	{	if(drawMap)
		{	g.setColor(0xffffff);
			g.fillRect(0,0,this.getWidth(),this.getHeight());
			String[] temp;						//Map Format: 0->X 1->Y 2->Type
			for(int x=0;x<blocks;x++)
			{	for(int y=0;y<blocks;y++)
				{	if(map[x][y].equals("BLOCK"))
						g.drawImage(block,x*blockSize,y*blockSize,Graphics.LEFT | Graphics.TOP);
					else if(map[x][y].equals("COIN"))
						g.drawImage(coin,x*blockSize,y*blockSize,Graphics.LEFT | Graphics.TOP);
					else if(map[x][y].equals("BULLET"))
						g.drawImage(bullet,x*blockSize,y*blockSize,Graphics.LEFT | Graphics.TOP);
				}
			}
		}
		if(drawPlayers)
		{	for(int i=0;i<4;i++)
			{	PlayerInfo temp=(PlayerInfo)pi.elementAt(i);
				
				if(temp.getFacing().equals("UP"))
				{	g.drawImage(tankUP[temp.playerNumber-1],temp.getX()*blockSize,temp.getY()*blockSize,Graphics.LEFT | Graphics.TOP);
				}
				else if(temp.getFacing().equals("DOWN"))
				{	g.drawImage(tankDOWN[temp.playerNumber-1],temp.getX()*blockSize,temp.getY()*blockSize,Graphics.LEFT | Graphics.TOP);
				}
				else if(temp.getFacing().equals("LEFT"))
				{	g.drawImage(tankLEFT[temp.playerNumber-1],temp.getX()*blockSize,temp.getY()*blockSize,Graphics.LEFT | Graphics.TOP);
				}
				else if(temp.getFacing().equals("RIGHT"))
				{	g.drawImage(tankRIGHT[temp.playerNumber-1],temp.getX()*blockSize,temp.getY()*blockSize,Graphics.LEFT | Graphics.TOP);
				}
			}
		}
		if(drawPowerUp)
		{	if(powerUp[2].equals("FIREPOWER"))
			{	g.drawImage(firepower,Integer.parseInt(powerUp[0])*blockSize,Integer.parseInt(powerUp[1])*blockSize,Graphics.LEFT | Graphics.TOP);
			}
			else if(powerUp[2].equals("TIMEFREEZE"))
			{	g.drawImage(timefreeze,Integer.parseInt(powerUp[0])*blockSize,Integer.parseInt(powerUp[1])*blockSize,Graphics.LEFT | Graphics.TOP);
			}
		}
		if(hasFired!=null)
		{	for(int i=0;i<hasFired.length;i++)
			{	String[] temp	=split(hasFired[i],',');
				int x			=Integer.parseInt(temp[0]);
				int y			=Integer.parseInt(temp[1]);
			
				g.drawImage(bullet,x*blockSize,y*blockSize,Graphics.LEFT | Graphics.TOP);
			}
		}
	}
	public void keyPressed(int keyCode)
	{	int action = getGameAction(keyCode);
        switch(action)
        {	case UP:
                if(gameStarted)
				{	client.sendMessage("UP "+playerNumber);
				}
                return;
            case DOWN:
                if(gameStarted)
				{	client.sendMessage("DOWN "+playerNumber);
				}
                return;
            case LEFT:
				if(gameStarted)
				{	client.sendMessage("LEFT "+playerNumber);
				}
                return;
            case RIGHT:
                if(gameStarted)
				{	client.sendMessage("RIGHT "+playerNumber);
				}
                return;
            case FIRE:
            	if(gameStarted)
				{	client.sendMessage("FIRE "+playerNumber);
				}
            	return;
            default:
                return;
        }
	}
	public String[] split(String input,char splitby)
	{	int ctr=0;
		int matches=0;
		String[] output;
		
		while(ctr<input.length())
		{	if(input.charAt(ctr)==splitby)
			{	matches++;
			}
			ctr++;
		}
		output=new String[matches+1];
		
		int from=999999999;
		int to=0;
		int outputCtr=0;
		for(int i=0;i<input.length();i++)
		{	if(from==999999999)
			{	from=i;
			}
			else if(input.charAt(i)==splitby)
			{	to=i;
				output[outputCtr++]=input.substring(from,to);
				from=999999999;
			}
			
			if(i==input.length()-1)
			{	to=i+1;
				output[outputCtr++]=input.substring(from,to);
			}
		}
		return output;
	}
}