import java.util.Vector;
import java.util.*;
import java.util.Date.*;

class GameLogic
{	private String[][] map;
	private Vector pi;
	private Vector bullets;
	int scoreSize=8;
	int coins=153;
	Server server;
	
	int sessionNumber;
	
	//Settings for PowerUPs
	int powerUpInterval=10;
    int intervalLeft=powerUpInterval;
    java.util.Timer timer;
    powerUpTask generatePowerUp;
    
    //Settings for TimeFreeze PowerUP
    int timeFreezeDuration=8;
    int timeLeft=timeFreezeDuration;
    java.util.Timer timerFreeze;
    timeFreezeTask timeFreeze;
    boolean onTimeFreeze=false;
    int playerOnTimeFreeze=99;
    
    //Resource for Bullets
    String[] hasFired;					//Format: X,Y,DIRECTION (INDEX = playerNumber)
    java.util.Timer timerBullet;
	bulletTask bullet;
    
    String[] powerUpType;
    
    public void resetGame()
    {	initMap();
		initResource();
		
		//timer.cancel();
		//timerFreeze.cancel();
		
		intervalLeft=powerUpInterval;
		
		timeLeft=timeFreezeDuration;
		onTimeFreeze=false;
		playerOnTimeFreeze=99;
    }

	public GameLogic(Server server,int sessionNumber)
	{	this.server=server;
		this.sessionNumber=sessionNumber;
	
		//Sets the PowerUp Types for PowerUp Generation
		powerUpType=new String[2];
		powerUpType[0]=new String("TIMEFREEZE");
		powerUpType[1]=new String("FIREPOWER");
		
		//Sets the Bullets "hasFired" to empty
		hasFired=new String[4];
		hasFired[0]="";
		hasFired[1]="";
		hasFired[2]="";
		hasFired[3]="";
		
		initMap();
		initResource();
	}
	class powerUpTask extends java.util.TimerTask
  	{	int randomer= new Date().getSeconds();
  		
  		public void run()
		{	if(intervalLeft==1)		//Time is up!
			{	int x=returnRandom()%16;
				int y=returnRandom()%16;
				int type=returnRandom()%2;
				
				while((!map[x][y].equals("COIN"))&&(!map[x][y].equals("SPACE")))
				{	x=returnRandom()%16;
					y=returnRandom()%16;
				}
				
				System.out.println("GENERATING POWERUP: "+x+","+y+","+powerUpType[type]);
				if(map[x][y].equals("COIN"))
				{	coins--;
				}
				map[x][y]=powerUpType[type];
				server.updateMapData(x,y,powerUpType[type],sessionNumber);
				timer.cancel();
			}
			else intervalLeft--;
		}
		private int returnRandom()
		{	Random random = new Random();
			
			random.setSeed(randomer);
		    randomer = random.nextInt();
		    
			if(randomer<0)
			{	randomer = randomer * -1;
			}
			return randomer;
		}
  	}
  	public void generatePowerUp()
  	{	timer = new java.util.Timer();
		generatePowerUp = new powerUpTask();
		timer.schedule (generatePowerUp, 0, 800);
		intervalLeft=powerUpInterval;
  	}
  	class timeFreezeTask extends java.util.TimerTask
  	{	public void run()
		{	if(timeLeft==1)
			{	onTimeFreeze=false;
				playerOnTimeFreeze=99;
				timerFreeze.cancel();
			}
			else timeLeft--;
		}
  	}
  	public void startTimeFreeze(int playerOnTimeFreeze)
  	{	onTimeFreeze=true;
  		this.playerOnTimeFreeze=playerOnTimeFreeze;
  		timerFreeze = new java.util.Timer();
		timeFreeze = new timeFreezeTask();
		timerFreeze.schedule (timeFreeze, 0, 800);
		timeLeft=timeFreezeDuration;
  	}
  	class bulletTask extends java.util.TimerTask
  	{	boolean sendClear=false;
  	
  		public void run()
		{	String message="/bulletData ";
			for(int i=0;i<4;i++)
			{	if(!hasFired[i].equals(""))
				{	String[] temp=hasFired[i].split(",");	//0->X 1->Y 2->DIRECTION 3->DAMAGE
					int x=Integer.parseInt(temp[0]);
					int y=Integer.parseInt(temp[1]);
					String direction=temp[2];
					int damage=Integer.parseInt(temp[3]);
					
					if(direction.equals("UP"))
					{	if(map[x][y-1].equals("SPACE")||map[x][y-1].equals("COIN")||
						   map[x][y-1].equals("TIMEFREEZE")||map[x][y-1].equals("FIREPOWER"))
						{	hasFired[i]=x+","+(y-1)+",UP,"+damage;
						}
						else if(map[x][y-1].equals("BLOCK"))
						{	hasFired[i]="";
						}
						else if(map[x][y-1].startsWith("PLAYER"))
						{	hasFired[i]="";
							((PlayerInfo)pi.elementAt(Integer.parseInt(map[x][y-1].substring(6))-1)).minusScore(damage);
						}
					}
					else if(direction.equals("DOWN"))
					{	if(map[x][y+1].equals("SPACE")||map[x][y+1].equals("COIN")||
						   map[x][y+1].equals("TIMEFREEZE")||map[x][y+1].equals("FIREPOWER"))
						{	hasFired[i]=x+","+(y+1)+",DOWN,"+damage;
						}
						else if(map[x][y+1].equals("BLOCK"))
						{	hasFired[i]="";
						}
						else if(map[x][y+1].startsWith("PLAYER"))
						{	hasFired[i]="";
							((PlayerInfo)pi.elementAt(Integer.parseInt(map[x][y+1].substring(6))-1)).minusScore(damage);
						}
					}
					else if(direction.equals("LEFT"))
					{	if(map[x-1][y].equals("SPACE")||map[x-1][y].equals("COIN")||
						   map[x-1][y].equals("TIMEFREEZE")||map[x-1][y].equals("FIREPOWER"))
						{	hasFired[i]=(x-1)+","+y+",LEFT,"+damage;
						}
						else if(map[x-1][y].equals("BLOCK"))
						{	hasFired[i]="";
						}
						else if(map[x-1][y].startsWith("PLAYER"))
						{	hasFired[i]="";
							((PlayerInfo)pi.elementAt(Integer.parseInt(map[x-1][y].substring(6))-1)).minusScore(damage);
						}
					}
					else if(direction.equals("RIGHT"))
					{	if(map[x+1][y].equals("SPACE")||map[x+1][y].equals("COIN")||
						   map[x+1][y].equals("TIMEFREEZE")||map[x+1][y].equals("FIREPOWER"))
						{	hasFired[i]=(x+1)+","+y+",RIGHT,"+damage;
						}
						else if(map[x+1][y].equals("BLOCK"))
						{	hasFired[i]="";
						}
						else if(map[x+1][y].startsWith("PLAYER"))
						{	hasFired[i]="";
							((PlayerInfo)pi.elementAt(Integer.parseInt(map[x+1][y].substring(6))-1)).minusScore(damage);
						}
					}
				}
				if(!hasFired[i].equals(""))
				{	String[] temp=hasFired[i].split(",");
					message=message+temp[0]+","+temp[1]+" ";
				}
			}
			if(!message.equals("/bulletData "))
			{	message=message.substring(0,message.length()-1);
				server.sendToAll(message,sessionNumber);
				sendClear=true;
			}
			else if(sendClear)
			{	server.sendToAll(message+"CLEAR",sessionNumber);
				sendClear=false;
			}
		}
  	}
  	public void createBullet(int playerNumber)
  	{	if(hasFired[playerNumber-1].equals(""))
  		{	int x			=((PlayerInfo)pi.elementAt(playerNumber-1)).getX();
	  		int y			=((PlayerInfo)pi.elementAt(playerNumber-1)).getY();
	  		String direction=((PlayerInfo)pi.elementAt(playerNumber-1)).getFacing();
	  		int damage		=((PlayerInfo)pi.elementAt(playerNumber-1)).firepower;
	  		
	  		hasFired[playerNumber-1]=x+","+y+","+direction+","+damage;
	  	}
  	}
  	public void startBulletTask()
  	{	timerBullet = new java.util.Timer();
		bullet		= new bulletTask();
		timerBullet.schedule(bullet, 0, 100);
  	}
	public void initResource()
	{	pi 		=new Vector();
		bullets	=new Vector();
	}
	public void addPlayers(int playerCount)
	{	/*	Player Default Coordinates:
			P1 - 1,1
			P2 - 15,15
			P3 - 15,1
			P4 - 1,15
		*/
		if(playerCount>=1)
		{	pi.addElement(new PlayerInfo(1,1,"DOWN",1));
			map[1][1]="PLAYER1";
		}
		if(playerCount>=2)
		{	pi.addElement(new PlayerInfo(15,15,"UP",2));
			map[15][15]="PLAYER2";
		}
		if(playerCount>=3)
		{	pi.addElement(new PlayerInfo(15,1,"DOWN",3));
			map[15][1]="PLAYER3";
		}
		if(playerCount==4)
		{	pi.addElement(new PlayerInfo(1,15,"UP",4));
			map[1][15]="PLAYER4";
		}
	}
	public void initMap()
	{	map=new String[17][17];
	
		//BORDER
		for(int i=0;i<17;i++)
			for(int j=0;j<17;j++)
				if(i==0||i==16||j==0||j==16)
					map[j][i] = new String("BLOCK");
		//ROWS 2,5,13,16
		for(int i=1;i<16;i++) 
			if(i==1||i==15)
			{	map[i][1] = new String("SPACE");
				map[i][4] = new String("COIN");
				map[i][12]= new String("COIN");
				map[i][15]= new String("SPACE");
			}
			else
			{	map[i][1] = new String("COIN");
				map[i][4] = new String("COIN");
				map[i][12]= new String("COIN");
				map[i][15]= new String("COIN");
			}
		//ROW 3 AND ROW 15
		for(int i=1;i<16;i++)
			if(i==1||i==8||i==15) {
				map[i][2] = new String("COIN");
				map[i][14]= new String("COIN");
			}
			else {
				map[i][2] = new String("BLOCK");
				map[i][14]= new String("BLOCK");
			}
		//ROWS 4,6,7,11,12,14		
		for(int i=1;i<16;i++)
			if(i==2||i==7||i==9||i==14)
			{	map[i][3] = new String("BLOCK");
				map[i][5] = new String("BLOCK");
				map[i][6] = new String("BLOCK");
				map[i][10]= new String("BLOCK");
				map[i][11]= new String("BLOCK");
				map[i][13]= new String("BLOCK");
			}
			else
			{	map[i][3] = new String("COIN");
				map[i][5] = new String("COIN");
				map[i][6] = new String("COIN");
				map[i][10]= new String("COIN");
				map[i][11]= new String("COIN");
				map[i][13]= new String("COIN");
			}
		//ROW 8 AND ROW 10
		for(int i=1;i<16;i++)
			if(i==2||i==5||i==6||i==7||i==9||i==10||i==11||i==14)
			{	map[i][7] = new String("BLOCK");
				map[i][9] = new String("BLOCK");
			}
			else 
			{	map[i][7] = new String("COIN");
				map[i][9] = new String("COIN");
			}
		//ROW 9
		for(int i=1;i<16;i++)
			if(i==1||i==2||i==14||i==15) 
				map[i][8] = new String("BLOCK");
			else
				map[i][8] = new String("COIN");				
	}
	public void playerMoveTo(String direction, int playerNumber)
	{	PlayerInfo currPlayerInfo=(PlayerInfo)pi.elementAt(playerNumber-1);
		int x=currPlayerInfo.getX();
		int y=currPlayerInfo.getY();
		boolean goIntoBullet=false;
	
		for(int i=0;i<4;i++)
		{	if(!hasFired[i].equals(""))
			{	String[] temp=hasFired[i].split(",");
				int bulletx	=Integer.parseInt(temp[0]);
				int bullety	=Integer.parseInt(temp[1]);
				int damage	=Integer.parseInt(temp[3]);
			
				if((direction.equals("UP")&&x==bulletx&&y-1==bullety)||
				   (direction.equals("DOWN")&&x==bulletx&&y+1==bullety)||
				   (direction.equals("LEFT")&&x-1==bulletx&&y==bullety)||
				   (direction.equals("RIGHT")&&x+1==bulletx&&y==bullety))
				{	hasFired[i]="";
					((PlayerInfo)pi.elementAt(playerNumber-1)).minusScore(damage);
					goIntoBullet=true;
				}
			}
		}
		
		if(((onTimeFreeze&&playerNumber==playerOnTimeFreeze)||(!onTimeFreeze))&&
	     	direction.equals("UP"))
		{	if(map[x][y-1].equals("SPACE")||map[x][y-1].equals("COIN")||
			   map[x][y-1].equals("TIMEFREEZE")||map[x][y-1].equals("FIREPOWER"))
			{	((PlayerInfo)pi.elementAt(playerNumber-1)).setY(y-1);
				
				if(map[x][y-1].equals("COIN"))
				{	((PlayerInfo)pi.elementAt(playerNumber-1)).addScore(scoreSize);
					coins--;
				}
				else if(map[x][y-1].equals("TIMEFREEZE"))
				{	generatePowerUp();
					startTimeFreeze(playerNumber);
				}
				else if(map[x][y-1].equals("FIREPOWER"))
				{	generatePowerUp();
					((PlayerInfo)pi.elementAt(playerNumber-1)).boostFirePower();
				}
				map[x][y]="SPACE";
				map[x][y-1]="PLAYER"+playerNumber;
			}
			((PlayerInfo)pi.elementAt(playerNumber-1)).setFacing("UP");
		}
		else if(((onTimeFreeze&&playerNumber==playerOnTimeFreeze)||(!onTimeFreeze))&&
				  direction.equals("DOWN"))
		{	if(map[x][y+1].equals("SPACE")||map[x][y+1].equals("COIN")||
			   map[x][y+1].equals("TIMEFREEZE")||map[x][y+1].equals("FIREPOWER"))
			{	((PlayerInfo)pi.elementAt(playerNumber-1)).setY(y+1);
				
				if(map[x][y+1].equals("COIN"))
				{	((PlayerInfo)pi.elementAt(playerNumber-1)).addScore(scoreSize);
					coins--;
				}
				else if(map[x][y+1].equals("TIMEFREEZE"))
				{	generatePowerUp();
					startTimeFreeze(playerNumber);
				}
				else if(map[x][y+1].equals("FIREPOWER"))
				{	generatePowerUp();
					((PlayerInfo)pi.elementAt(playerNumber-1)).boostFirePower();
				}
				map[x][y]="SPACE";
				map[x][y+1]="PLAYER"+playerNumber;
			}
			((PlayerInfo)pi.elementAt(playerNumber-1)).setFacing("DOWN");
		}
		else if(((onTimeFreeze&&playerNumber==playerOnTimeFreeze)||(!onTimeFreeze))&&
				  direction.equals("LEFT"))
		{	if(map[x-1][y].equals("SPACE")||map[x-1][y].equals("COIN")||
			   map[x-1][y].equals("TIMEFREEZE")||map[x-1][y].equals("FIREPOWER"))
			{	((PlayerInfo)pi.elementAt(playerNumber-1)).setX(x-1);
				
				if(map[x-1][y].equals("COIN"))
				{	((PlayerInfo)pi.elementAt(playerNumber-1)).addScore(scoreSize);
					coins--;
				}
				else if(map[x-1][y].equals("TIMEFREEZE"))
				{	generatePowerUp();
					startTimeFreeze(playerNumber);
				}
				else if(map[x-1][y].equals("FIREPOWER"))
				{	generatePowerUp();
					((PlayerInfo)pi.elementAt(playerNumber-1)).boostFirePower();
				}
				map[x][y]="SPACE";
				map[x-1][y]="PLAYER"+playerNumber;
			}
			((PlayerInfo)pi.elementAt(playerNumber-1)).setFacing("LEFT");
		}
		else if(((onTimeFreeze&&playerNumber==playerOnTimeFreeze)||(!onTimeFreeze))&&
				  direction.equals("RIGHT"))
		{	if(map[x+1][y].equals("SPACE")||map[x+1][y].equals("COIN")||
			   map[x+1][y].equals("TIMEFREEZE")||map[x+1][y].equals("FIREPOWER"))
			{	((PlayerInfo)pi.elementAt(playerNumber-1)).setX(x+1);
				
				if(map[x+1][y].equals("COIN"))
				{	((PlayerInfo)pi.elementAt(playerNumber-1)).addScore(scoreSize);
					coins--;
				}
				else if(map[x+1][y].equals("TIMEFREEZE"))
				{	generatePowerUp();
					startTimeFreeze(playerNumber);
				}
				else if(map[x+1][y].equals("FIREPOWER"))
				{	generatePowerUp();
					((PlayerInfo)pi.elementAt(playerNumber-1)).boostFirePower();
				}
				map[x][y]="SPACE";
				map[x+1][y]="PLAYER"+playerNumber;
			}
			((PlayerInfo)pi.elementAt(playerNumber-1)).setFacing("RIGHT");
		}
		if(coins==0)
		{	String message="/gameFinished ";
			timer.cancel();
		
			for(int i=0;i<pi.size();i++)
			{	message=message+i+","+((PlayerInfo)pi.elementAt(i)).score;
				
				if(i!=pi.size()-1)
					message=message+" ";
			}
			
			server.sendToAll(message,sessionNumber);
		}
	}
	public String[][] getMapData()
	{	return map;
	}
	public PlayerInfo getPlayerData(int playerNum)
	{	if(playerNum<=pi.size())
		{	return (PlayerInfo)pi.elementAt(playerNum-1);
		}
		else
		{	System.out.println("Error!");
			return null;
		}
	}
}