import java.io.*;
import java.net.*;
import javax.swing.*;
import java.util.*;

public class ServerThread extends Thread
{	private Server server;
	private Socket socket;
	private int sessionNumber;
		
	public ServerThread( Server server, Socket socket, int sessionNumber)
	{	this.server = server;
		this.socket = socket;
		this.sessionNumber=sessionNumber;
		start();
	}
	public void run()
	{	try 
		{	DataInputStream din = new DataInputStream( socket.getInputStream() );
							
			while (true)
			{	
				String message = din.readUTF();	
				System.out.println(message);
				
				if(message.equals("/startGame"))
				{	server.sendToAll("/disableStart",sessionNumber);
					server.startCountdown();
				}
				else if(message.startsWith("UP")||message.startsWith("DOWN")||
						message.startsWith("LEFT")||message.startsWith("RIGHT"))
				{	//Format: 0->Direction 1->PlayerNumber
				
					String temp[]=message.split(" ");
					server.getGL(sessionNumber).playerMoveTo(temp[0],Integer.parseInt(temp[1]));
					server.sendPlayerData(Integer.parseInt(temp[1]),sessionNumber);
				}
				else if(message.startsWith("FIRE"))
				{	message=message.substring(5);
					server.getGL(sessionNumber).createBullet(Integer.parseInt(message));
				}
			}
		}
	
		catch( EOFException ie )	{} 
		catch( IOException ie )		{}
		finally
		{	server.removeConnection(socket,sessionNumber);
		}
	}
}